/* pmudmon applet
 ** Copyright (C) 2000 Mike Palczewski mpalczew@u.washington.edu
 ** 
 ** This program is free software; you can redistribute it and/or
 ** modify it under the terms of the GNU General Public License
 ** as published by the Free Software Foundation; either version 2
 ** of the License, or (at your option) any later version.
 ** 
 ** This program is distributed in the hope that it will be useful,
 ** but WITHOUT ANY WARRANTY; without even the implied warranty of
 ** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 ** GNU General Public License for more details.
 ** 
 ** You should have received a copy of the GNU General Public License
 ** along with this program; if not, write to the Free Software
 ** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  
 ** 02111-1307, USA.
 **/
#include <sys/types.h>
#include <sys/socket.h>
#include <stdio.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <unistd.h>
#include <applet-widget.h>

#define PACKAGE "pmudmon"
#define VERSION "0.1"

GtkWidget* progress;
char buffer[80];
int sockfd;

gint pmudmain(gpointer data);
void getLine();

int main(int argc, char **argv)
	{
	GtkWidget* applet;
	applet_widget_init(PACKAGE, VERSION, argc, argv,
			        NULL, 0, NULL);
        initpmud();	
	applet = applet_widget_new(PACKAGE); 
	progress=gtk_progress_bar_new();
	gtk_progress_set_show_text(GTK_PROGRESS(progress),1);
	applet_widget_add(APPLET_WIDGET(applet), progress); 
        gtk_widget_show(applet);
	gtk_widget_show(progress);
        gtk_timeout_add( 10000,pmudmain,NULL);
	
	getLine(); /* flush the first line as it is the version line */
	
	applet_widget_gtk_main(); 
        close(sockfd);
	return 0;
}



gint initpmud(gpointer data) {
	int len;

	struct sockaddr_in address;
	int result;
	char ch='A';
	char ci='\n';
	
	sockfd=socket(AF_INET,SOCK_STREAM,0);
	address.sin_family = AF_INET;
	address.sin_addr.s_addr = inet_addr("127.0.0.1");
	address.sin_port=879;
	len=sizeof(address);

	result=connect(sockfd,(struct sockaddr *)&address,len);

	if (result == -1) {
		puts("cannot connect to pmud");
		exit(0);
	}
}

gint pmudmain(gpointer data) {
	int a,batnow=0,battot=0,status=0;
	
	getLine();
	a=sscanf(buffer,"%*s {%d %d %d %*s %*s %*s",&status,&batnow,&battot);
	if (batnow != 0 &&  battot != 0)  
		gtk_progress_set_percentage(GTK_PROGRESS(progress),(float)batnow/(float)battot);	
	switch (status) {
	   	case 111:
			gtk_progress_set_format_string(GTK_PROGRESS(progress),"AC charging %p%%");
			break;
		case 001:
			gtk_progress_set_format_string(GTK_PROGRESS(progress),"Battery %p%%");
			break;
		case 101:
			gtk_progress_set_format_string(GTK_PROGRESS(progress),"AC charged %p%%");
			break;
		default:
			gtk_progress_set_format_string(GTK_PROGRESS(progress),"Unknown condition %p%%");
			break;
	}
}

void getLine() {
	char ch=0;
	char ci='\n';
	int i;	
	
	
	write (sockfd,&ci,1);
	for (i=0;ch!='\n' && i < 80;i++) {
		read(sockfd,&buffer[i],1);
		ch=buffer[i];
	}
	buffer[i]=0;

	if (buffer[0]== 0 || buffer[0]== '\n' )
		getLine();

	for (i=0;buffer[i] != 0; i++) {
		if (buffer[i] == '\n') buffer[i]=0;	
	}
}	




